Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/ExistsFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/ExistsFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/ExistsFunction.java	(revision 44738)
@@ -0,0 +1,116 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.function.dataaccess;
+
+import java.util.List;
+import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.Codes;
+import org.gvsig.expressionevaluator.ExpressionRuntimeException;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.util.UnmodifiableBasicCollection;
+import org.gvsig.tools.util.UnmodifiableBasicCollection64;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class ExistsFunction extends AbstractFunction {
+
+  public static final String NAME = "EXISTS";
+
+  public ExistsFunction() {
+    //
+    // https://www.postgresql.org/docs/current/functions-subquery.html
+    //
+    // Nota:
+    // En H2 no existe la funcion EXISTS, pero muy probablemente se pueda
+    // trasladar a:
+    //   NVL2(COALESCE(lista-subselect),FALSE,TRUE)
+    //
+    super(DALFunctions.SYMBOLTABLE_NAME,
+            DALFunctions.FUNCTION_EXISTS,
+            Range.between(1, 2),
+            "Receive a list as an argument. Returns true if the list has some value and false if the list is empty.",
+            DALFunctions.FUNCTION_EXISTS + "({{list}})",
+            new String[]{
+              "list - a list of values or null"
+            },
+            "Boolean",
+            true
+    );
+  }
+
+  @Override
+  public boolean allowConstantFolding() {
+    return false;
+  }
+
+  @Override
+  public boolean useArgumentsInsteadObjects() {
+    return true;
+  }
+
+  @Override
+  public Object call(Interpreter interpreter, Object[] args) throws Exception {
+    throw new UnsupportedOperationException("Not supported yet.");
+  }
+
+  @Override
+  public Object call(Interpreter interpreter, Codes args) throws Exception {
+    if (args.size() == 2) {
+      Object id = this.getObject(interpreter, args, 1);
+      if (id instanceof CharSequence) {
+        if (interpreter.getSymbolTable().exists(id.toString())) {
+          Object value = interpreter.getSymbolTable().value(id.toString());
+          if (value == null) {
+            return false;
+          }
+          if (value instanceof Boolean) {
+            return value;
+          }
+        }
+      }
+    }
+
+    Object list = this.getObject(interpreter, args, 0);
+    if (list == null) {
+      return false;
+    }
+    boolean isEmpty = true;
+    if (list instanceof List) {
+      isEmpty = ((List) list).isEmpty();
+    } else if (list instanceof UnmodifiableBasicCollection) {
+      isEmpty = ((UnmodifiableBasicCollection) list).isEmpty();
+    } else if (list instanceof UnmodifiableBasicCollection64) {
+      isEmpty = ((UnmodifiableBasicCollection64) list).isEmpty();
+    } else {
+      throw new ExpressionRuntimeException("Invalid argument. List or null expected.");
+    }
+//    System.out.println("EXISTS: "+ interpreter.getSymbolTable().value("NAME")+", "+isEmpty);
+    return !isEmpty;
+  }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/IsSelectedCurrentRowFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/IsSelectedCurrentRowFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/IsSelectedCurrentRowFunction.java	(revision 44738)
@@ -0,0 +1,74 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.function.dataaccess;
+
+import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.dal.feature.FeatureSelection;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class IsSelectedCurrentRowFunction extends AbstractFunction {
+  
+  public IsSelectedCurrentRowFunction() {
+    super(
+            DALFunctions.GROUP_DATA_ACCESS, 
+            DALFunctions.FUNCTION_ISSELECTED_CURRENT_ROW, 
+            Range.is(0), 
+            "Return if the current feature is selected in the store when used in a filter.\n" 
+                    + "Return false if used outer a filter.", 
+            DALFunctions.FUNCTION_ISSELECTED_CURRENT_ROW+"()", 
+            null, 
+            "Boolean",
+            false
+    );
+  }
+
+  private Feature current_row(Interpreter interpreter) {
+    try {
+      Feature f = (Feature) interpreter.call(DALFunctions.FUNCTION_CURRENT_ROW);
+      return f;
+    } catch (Exception ex) {
+      return null;
+    }
+  }
+
+  @Override
+  public Object call(Interpreter interpreter, Object[] args) throws Exception {
+    Feature feature = current_row(interpreter);
+    if (feature == null) {
+      return false;
+    }
+    FeatureStore store = feature.getStore();
+    FeatureSelection selection = store.getFeatureSelection();
+    return selection.isSelected(feature);
+  }
+  
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/SelectFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/SelectFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/dataaccess/SelectFunction.java	(revision 44738)
@@ -0,0 +1,150 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.function.dataaccess;
+
+import java.util.List;
+import java.util.Objects;
+import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.Codes;
+import org.gvsig.expressionevaluator.Expression;
+import org.gvsig.expressionevaluator.ExpressionRuntimeException;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.fmap.dal.DALLocator;
+import org.gvsig.fmap.dal.DataManager;
+import org.gvsig.fmap.dal.DataStore;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.dal.feature.FeatureQuery;
+import org.gvsig.fmap.dal.feature.FeatureQueryOrder;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class SelectFunction extends AbstractFunction {
+
+  public SelectFunction() {
+    super(DALFunctions.GROUP_DATA_ACCESS,
+            DALFunctions.FUNCTION_SELECT,
+            Range.between(1,1000),
+            "Returns a list of features of the indicated table by applying the filter and order indicated..",
+            DALFunctions.FUNCTION_SELECT + "({{table_name}},filter, order, limit)",
+            new String[]{
+              "table_name - Name of the table",
+              "filter - filter to apply",
+              "order - the order used to retrieve the features",
+              "limit - Maximum number of features to return"
+            },
+            "List",
+            true
+    );
+  }
+
+  @Override
+  public boolean isHidden() {
+    return true;
+  }
+
+  @Override
+  public boolean allowConstantFolding() {
+    return false;
+  }
+
+  @Override
+  public boolean allowArgNames() {
+    return true;
+  }
+
+  @Override
+  public boolean useArgumentsInsteadObjects() {
+    return true;
+  }
+
+  @Override
+  public Object call(Interpreter interpreter, Object[] args) throws Exception {
+    throw new UnsupportedOperationException();
+  }
+
+  @Override
+  public Object call(Interpreter interpreter, Codes args) throws Exception {
+
+    String storeName =  (String) getObject(interpreter, args, "TABLE");
+    String where = Objects.toString(args.get("WHERE"),null);
+    Number limit = (Number) getObject(interpreter, args, "LIMIT");
+    FeatureQueryOrder order = null;
+    for( int n=0 ; args.contains("ORDER", n); n++) {
+      String member = (String) getObject(interpreter, args, "ORDER", n);
+      Boolean mode = (Boolean) getObject(interpreter, args, "ORDER_MODE", n);
+      if( order == null ) {
+        order = new FeatureQueryOrder();
+      }
+      order.add(member, mode);
+    }
+    
+    try {
+      DataStore store = this.getStore(storeName);
+      if (store == null ) {
+        throw new ExpressionRuntimeException("Cant locate the store '" + storeName + "' in function '" + DALFunctions.FUNCTION_SELECT + "'.");
+      }
+      if (!(store instanceof FeatureStore)) {
+        throw new ExpressionRuntimeException("The store'" + storeName + "' is not valid for function '" + DALFunctions.FUNCTION_SELECT + "', a FeatureStore is required.");
+      }
+      FeatureStore featureStore = (FeatureStore) store;
+      List<Feature> features;
+      if (where == null && order == null && limit==null ) {
+        features = featureStore.getFeatures();
+      } else {
+        FeatureQuery query = featureStore.createFeatureQuery();
+        if (where != null) {
+          Expression filter = ExpressionUtils.createExpression(where);
+          filter.getSymbolTable().addSymbolTable(interpreter.getSymbolTable());
+          query.addFilter(filter);
+        }
+        if (order != null) {
+          query.getOrder().copyFrom(order);
+        }
+        if( limit!=null ) {
+          query.setLimit(limit.longValue());
+        }
+        query.retrievesAllAttributes();
+        features = featureStore.getFeatures(query);
+      }
+      return features;
+    } catch (ExpressionRuntimeException ex) {
+      throw ex;
+    } catch (Exception ex) {
+      throw new ExpressionRuntimeException("Problems calling '" + DALFunctions.FUNCTION_SELECT + "' function", ex);
+    }
+  }
+
+  protected DataStore getStore(String storeName) {
+    DataManager dataManager = DALLocator.getDataManager();
+    DataStore store = dataManager.getStoresRepository().getStore(storeName);
+    return store;
+  }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/DALFunctions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/DALFunctions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/DALFunctions.java	(revision 44738)
@@ -0,0 +1,46 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public interface DALFunctions {
+
+  public static final String SYMBOLTABLE_NAME = "DataAccess";
+  public static final String GRAMMAR_NAME = "DataAccess";
+
+  public static final String GROUP_DATA_ACCESS = "Data access";
+
+  public static final String FUNCTION_CURRENT_ROW = "CURRENT_ROW";
+  public static final String FUNCTION_CURRENT_STORE = "CURRENT_STORE";
+  public static final String FUNCTION_ISSELECTED_CURRENT_ROW = "ISSELECTED_CURRENT_ROW";
+
+  public static final String FUNCTION_SELECT = "SELECT";
+  public static final String FUNCTION_SELECT_COUNT = "SELECT_COUNT";
+  public static final String FUNCTION_EXISTS = "EXISTS";
+  public static final String FUNCTION_FOREING_VALUE = "FOREING_VALUE";
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/grammars/DataAccessGrammarFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/grammars/DataAccessGrammarFactory.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/grammars/DataAccessGrammarFactory.java	(revision 44738)
@@ -0,0 +1,168 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.grammars;
+
+import java.util.UUID;
+import org.gvsig.expressionevaluator.Code;
+import org.gvsig.expressionevaluator.Code.Caller;
+import org.gvsig.expressionevaluator.CodeBuilder;
+import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
+import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
+import org.gvsig.expressionevaluator.Grammar;
+import org.gvsig.expressionevaluator.Statement;
+import org.gvsig.expressionevaluator.Statement.StatementContext;
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.impl.DefaultCodeBuilder.BaseCodes;
+import org.gvsig.expressionevaluator.impl.DefaultStatement;
+import org.gvsig.expressionevaluator.impl.DefaultStatement.ArgsBuilderFromNames;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.ExistsFunction;
+import org.gvsig.expressionevaluator.spi.AbstractGrammarFactory;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class DataAccessGrammarFactory extends AbstractGrammarFactory {
+
+    private Grammar grammar;
+
+    private class ExistsStatementBuilder extends DefaultStatement.StatementBuilderBase {
+
+        private final String ListID;
+
+        public ExistsStatementBuilder(String ListID) {
+            super(ExistsFunction.NAME, new ArgsBuilderFromNames(ListID));
+            this.ListID = ListID;
+        }
+
+        @Override
+        public Code build(StatementContext context) {
+            UUID x = UUID.randomUUID();
+            String exists_id = x.toString().replaceAll("-", "");
+
+            CodeBuilder codeBuilder = context.getCodeBuilder();
+            Caller code = (Caller) super.build(context);
+            BaseCodes args = (BaseCodes) code.parameters();
+            args.add("EXISTS_ID", codeBuilder.constant(exists_id));
+            code = codeBuilder.function(ExistsFunction.NAME, args);
+            return code;
+        }
+        
+    }
+    public DataAccessGrammarFactory() {
+        super(DALFunctions.GRAMMAR_NAME, true);
+    }
+    
+    @Override
+    public Grammar create(Object... parameters) {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        if( this.grammar==null ) {
+            Grammar theGrammar = manager.createGrammar(this.getName());
+            Statement stmt;
+        
+            theGrammar.addReservedWord("EXISTS");
+            theGrammar.addReservedWord("SELECT");
+            theGrammar.addReservedWord("FROM");
+            theGrammar.addReservedWord("WHERE");
+            theGrammar.addReservedWord("ORDER");
+            theGrammar.addReservedWord("DESC");
+            theGrammar.addReservedWord("ASC");
+            theGrammar.addReservedWord("BY");
+            
+            stmt = theGrammar.createStatement("EXISTS");
+            stmt.addRule(stmt.require_any_token("EXISTS"));
+            stmt.addRule(stmt.require_expression("LIST"));
+            stmt.builder(new ExistsStatementBuilder("LIST"));
+            theGrammar.addStatement(stmt);
+
+
+            stmt = theGrammar.createStatement("SELECT");
+            stmt.addRule(stmt.require_any_token("SELECT"));
+            stmt.addRule(stmt.require_any_token("*","1"));
+            stmt.addRule(stmt.require_any_token("FROM"));
+            stmt.addRule(stmt.require_identifier("TABLE"));
+            stmt.addRule(stmt.optional_any_token("WHERE")
+                    .addRuleOnTrue(stmt.require_expression("WHERE"))
+            );
+            
+            stmt.addRule(stmt.optional_any_token("ORDER")
+                    .addRuleOnTrue(stmt.require_any_token("BY"))
+                    .addRuleOnTrue(
+                      stmt.repeat()
+                          .addRule(stmt.require_expression("ORDER#"))
+                          .addRule(stmt.switch_token()
+                                  .addCase("ASC", 
+                                          stmt.set_expression("ORDER_MODE#", true)
+                                  )
+                                  .addCase("DESC", 
+                                          stmt.set_expression("ORDER_MODE#", false)
+                                  )
+                                  .addDefault(
+                                          stmt.set_expression("ORDER_MODE#", true)
+                                  )
+                          )
+                          .addRule(
+                              stmt.optional_any_token(",")
+                                  .addRuleOnFalse(stmt.break_loop())
+                          )
+                    )
+            );    
+            stmt.addRule(stmt.optional_any_token("LIMIT")
+                    .addRuleOnTrue(stmt.require_expression("LIMIT"))
+            );
+            stmt.addRule(stmt.require_any_token(";"));
+            stmt.code(
+                    DALFunctions.FUNCTION_SELECT,
+                    stmt.args_names("TABLE","WHERE","ORDER#","ORDER_MODE#","LIMIT")
+            ); 
+            theGrammar.addStatement(stmt);
+
+            stmt = theGrammar.createStatement("SELECT_COUNT");
+            stmt.addRule(stmt.require_any_token("SELECT"));
+            stmt.addRule(stmt.require_any_token("COUNT"));
+            stmt.addRule(stmt.require_any_token("("));
+            stmt.addRule(stmt.require_any_token("*"));
+            stmt.addRule(stmt.require_any_token(")"));
+            stmt.addRule(stmt.require_any_token("FROM"));
+            stmt.addRule(stmt.require_identifier("TABLE"));
+            stmt.addRule(stmt.optional_any_token("WHERE")
+                    .addRuleOnTrue(stmt.require_expression("WHERE"))
+            );
+            stmt.addRule(stmt.require_any_token(";"));
+            stmt.code(
+                    DALFunctions.FUNCTION_SELECT_COUNT,
+                    stmt.args_names("TABLE","WHERE")
+            ); 
+            theGrammar.addStatement(stmt);
+
+            this.grammar = theGrammar;
+        }
+        return grammar;
+    }
+ 
+    public static final void selfRegister() {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        manager.registerGrammar(new DataAccessGrammarFactory());
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/DALExpressionEvaluatorImplLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/DALExpressionEvaluatorImplLibrary.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/DALExpressionEvaluatorImplLibrary.java	(revision 44738)
@@ -0,0 +1,51 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl;
+
+import org.gvsig.expressionevaluator.ExpressionEvaluatorLibrary;
+import org.gvsig.expressionevaluator.impl.symboltable.DALSymbolTableFactory;
+import org.gvsig.fmap.dal.DALLibrary;
+import org.gvsig.tools.ToolsLibrary;
+import org.gvsig.tools.library.AbstractLibrary;
+import org.gvsig.tools.library.LibraryException;
+
+public class DALExpressionEvaluatorImplLibrary extends AbstractLibrary {
+
+    @Override
+    public void doRegistration() {
+        registerAsServiceOf(ExpressionEvaluatorLibrary.class);
+        require(ToolsLibrary.class);
+        require(DALLibrary.class);
+    }
+
+    @Override
+    protected void doInitialize() throws LibraryException {
+    }
+
+    @Override
+    protected void doPostInitialize() throws LibraryException {
+        DALSymbolTableFactory.selfRegister();
+    }
+}
+
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/DALSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/DALSymbolTable.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/DALSymbolTable.java	(revision 44738)
@@ -0,0 +1,59 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.symboltable;
+
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.CurrentRowFunction;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.CurrentStoreFunction;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.ExistsFunction;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.ForeingValueFunction;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.IsSelectedCurrentRowFunction;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.SelectCountFunction;
+import org.gvsig.expressionevaluator.impl.function.dataaccess.SelectFunction;
+import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class DALSymbolTable 
+        extends AbstractSymbolTable
+    {   
+
+    public DALSymbolTable() {
+        super(DALFunctions.SYMBOLTABLE_NAME);
+        this.initFunctions();
+    }
+    
+    private void initFunctions() {
+        this.addFunction(new ExistsFunction());
+        this.addFunction(new SelectFunction());
+        this.addFunction(new SelectCountFunction());
+        this.addFunction(new CurrentRowFunction());
+        this.addFunction(new CurrentStoreFunction());
+        this.addFunction(new ForeingValueFunction());
+        this.addFunction(new IsSelectedCurrentRowFunction());
+        this.addFunction(new ForeingValueFunction());
+    }    
+}
